;============================================
; Child Window Testbed
;============================================


	INCLUDE	\masm32\include\masm32rt.inc


;============================================
; Defines, macros, prototypes, etc.
;============================================

WinMain			PROTO :DWORD
ChildProc		PROTO hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

$mainWindowWidth	EQU 900
$mainWindowHeight	EQU 500

;===== Status bar stuff: =====
$SBID			EQU 2000
$SBX			EQU 0
$SBY			EQU $mainWindowHeight - $SBHeight
$SBWidth		EQU $mainWindowWidth
$SBHeight		EQU $mainWindowHeight - 10
$numStatusParts		EQU 2
$statusLen		EQU 200

;===== Pushbutton stuff: =====
$PBID			EQU 2001
$PBX			EQU 10
$PBY			EQU $mainWindowHeight - 150
$PBWidth		EQU 100
$PBHeight		EQU 25

$childID		EQU 2002
$childX			EQU 10
$childY			EQU 10
$childWidth		EQU $mainWindowWidth - 30
$childHeight		EQU $mainWindowHeight - 200

;===== Window styles: =====
$mainWinAttrs		EQU WS_OVERLAPPED OR WS_CLIPCHILDREN OR WS_VISIBLE OR WS_CAPTION \
				OR WS_SYSMENU
$chkboxAttrs		EQU WS_CHILD OR WS_VISIBLE OR BS_AUTOCHECKBOX OR WS_TABSTOP OR WS_CLIPSIBLINGS
$SB_attrs		EQU WS_CHILD OR WS_VISIBLE OR WS_CLIPSIBLINGS
$PB_attrs		EQU WS_CHILD OR WS_VISIBLE OR BS_PUSHBUTTON OR WS_CLIPSIBLINGS

;===== Window background colors: =====
$bkRED			EQU 254
$bkGRN			EQU 243
$bkBLUE			EQU 199

$BkColor		EQU $bkRED OR ($bkGRN SHL 8) OR ($bkBLUE SHL 16)

; Structure for creating checkbox controls:
$chkbox			STRUCT
  ID			DD ?
  x			DD ?
  y			DD ?
  wdth			DD ?
  height		DD ?
  wstyle		DD ?
  textPtr		DD ?
  handle		HWND ?
$chkbox			ENDS

$chkBase		EQU 3000
$chkBORDER		EQU $chkBase
$chkCAPTION		EQU $chkBase + 1
$chkCHILD		EQU $chkBase + 2
$chkCLIPCHILDREN	EQU $chkBase + 3
$chkCLIPSIBLINGS	EQU $chkBase + 4
$chkDISABLED		EQU $chkBase + 5
$chkDLGFRAME		EQU $chkBase + 6
$chkGROUP		EQU $chkBase + 7
$chkHSCROLL		EQU $chkBase + 8
$chkMAXIMIZE		EQU $chkBase + 9
$chkMINIMIZE		EQU $chkBase + 10
$chkMAXIMIZEBOX		EQU $chkBase + 11
$chkMINIMIZEBOX		EQU $chkBase + 12
$chkOVERLAPPED		EQU $chkBase + 13
$chkOVERLAPPEDWINDOW	EQU $chkBase + 14
$chkPOPUP		EQU $chkBase + 15
$chkPOPUPWINDOW		EQU $chkBase + 16
$chkSIZEBOX		EQU $chkBase + 17
$chkSYSMENU		EQU $chkBase + 18
$chkTABSTOP		EQU $chkBase + 19
$chkVISIBLE		EQU $chkBase + 20
$chkVSCROLL		EQU $chkBase + 21

$ch1X			EQU 386
$ch2X			EQU 408
$ch3X			EQU 430


$cr			EQU 13
$lf			EQU 10


;============================================
; HERE BE DATA
;============================================

.data

InstanceHandle		HWND ?
MainWinHandle		HWND ?
StatusHandle		HWND ?
ButtonHandle		HWND ?
ChildHandle		HWND NULL

FontHandle		HGDIOBJ ?

OldChildProcPtr		DD ?

BkBrush			DD ?

SBheight		DD ?
StatusParts		DD $statusLen, -1
WindowStyles		DD 0

; Table for creating checkbox controls (what a nightmare this would be otherwise!)
CheckboxInfo		LABEL DWORD
  $chkbox <$chkBORDER,		10, $ch1X, 100, 20,	WS_BORDER, ChkBORDERtext>
  $chkbox <$chkCAPTION,		110, $ch1X, 100, 20,	WS_CAPTION, ChkCAPTIONtext>
  $chkbox <$chkCHILD,		210, $ch1X, 80, 20,	WS_CHILD, ChkCHILDtext>
  $chkbox <$chkCLIPCHILDREN,	290, $ch1X, 130, 20,	WS_CLIPCHILDREN, ChkCLIPCHILDRENtext>
  $chkbox <$chkCLIPSIBLINGS,	420, $ch1X, 120, 20,	WS_CLIPSIBLINGS, ChkCLIPSIBLINGStext>
  $chkbox <$chkDISABLED,	540, $ch1X, 100, 20,	WS_DISABLED, ChkDISABLEDtext>
  $chkbox <$chkDLGFRAME,	640, $ch1X, 110, 20,	WS_DLGFRAME, ChkDLGFRAMEtext>
  $chkbox <$chkGROUP,		750, $ch1X, 90, 20,	WS_GROUP, ChkGROUPtext>
  $chkbox <$chkHSCROLL,		10, $ch2X, 100, 20,	WS_HSCROLL, ChkHSCROLLtext>
  $chkbox <$chkMAXIMIZE,	110, $ch2X, 100, 20,	WS_MAXIMIZE, ChkMAXIMIZEtext>
  $chkbox <$chkMINIMIZE,	210, $ch2X, 100, 20,	WS_MINIMIZE, ChkMINIMIZEtext>
  $chkbox <$chkMAXIMIZEBOX,	310, $ch2X, 120, 20,	WS_MAXIMIZEBOX, ChkMAXIMIZEBOXtext>
  $chkbox <$chkMINIMIZEBOX,	430, $ch2X, 120, 20,	WS_MINIMIZEBOX, ChkMINIMIZEBOXtext>
  $chkbox <$chkOVERLAPPED,	550, $ch2X, 120, 20,	WS_OVERLAPPED, ChkOVERLAPPEDtext>
  $chkbox <$chkOVERLAPPEDWINDOW,670, $ch2X, 170, 20,	WS_OVERLAPPEDWINDOW, ChkOVERLAPPEDWINDOWtext>
  $chkbox <$chkPOPUP,		10, $ch3X, 90, 20,	WS_POPUP, ChkPOPUPtext>
  $chkbox <$chkPOPUPWINDOW,	100, $ch3X, 140, 20,	WS_POPUPWINDOW, ChkPOPUPWINDOWtext>
  $chkbox <$chkSIZEBOX,		240, $ch3X, 100, 20,	WS_SIZEBOX, ChkSIZEBOXtext>
  $chkbox <$chkSYSMENU,		340, $ch3X, 100, 20,	WS_SYSMENU, ChkSYSMENUtext>
  $chkbox <$chkTABSTOP,		440, $ch3X, 100, 20,	WS_TABSTOP, ChkTABSTOPtext>
  $chkbox <$chkVISIBLE,		540, $ch3X, 90, 20,	WS_VISIBLE, ChkVISIBLEtext>
  $chkbox <$chkVSCROLL,		630, $ch3X, 100, 20,	WS_VSCROLL, ChkVSCROLLtext>
  $chkbox <-1>		;marks the end

MainClassName		DB "ChildTest", 0
ButtonClassName		DB "button", 0

MainTitleText		DB "Child Window Creation Testbed", 0
ChildTitleText		DB "Child Window", 0
NullString		DB 0
PBText			DB "Create window", 0

ChkBORDERtext		DB "WS_BORDER", 0
ChkCAPTIONtext		DB "WS_CAPTION", 0
ChkCHILDtext		DB "WS_CHILD", 0
ChkCLIPCHILDRENtext	DB "WS_CLIPCHILDREN", 0
ChkCLIPSIBLINGStext	DB "WS_CLIPSIBLINGS", 0
ChkDISABLEDtext		DB "WS_DISABLED", 0
ChkDLGFRAMEtext		DB "WS_DLGFRAME", 0
ChkGROUPtext		DB "WS_GROUP", 0
ChkHSCROLLtext		DB "WS_HSCROLL",0
ChkMAXIMIZEtext		DB "WS_MAXIMIZE", 0
ChkMINIMIZEtext		DB "WS_MINIMIZE", 0
ChkMAXIMIZEBOXtext	DB "WS_MAXIMIZEBOX", 0
ChkMINIMIZEBOXtext	DB "WS_MINIMIZEBOX", 0
ChkOVERLAPPEDtext	DB "WS_OVERLAPPED", 0
ChkOVERLAPPEDWINDOWtext	DB "WS_OVERLAPPEDWINDOW",0
ChkPOPUPtext		DB "WS_POPUP", 0
ChkPOPUPWINDOWtext	DB "WS_POPUPWINDOW", 0
ChkSIZEBOXtext		DB "WS_SIZEBOX", 0
ChkSYSMENUtext		DB "WS_SYSMENU", 0
ChkTABSTOPtext		DB "WS_TABSTOP", 0
ChkVISIBLEtext		DB "WS_VISIBLE", 0
ChkVSCROLLtext		DB "WS_VSCROLL", 0


WindowTestText		DB "This is a block of text to see how the child window behaves with content.", $cr, $lf
			DB "This should give you an idea of how text will appear in the", $cr, $lf
			DB "client area of the child window, once it's filled with several lines", $cr, $lf
			DB "of text (and possibly other stuff, like bitmaps, drawing objects", $cr, $lf
			DB "or who know what). Keep in mind that this window has only very minimal processing", $cr, $lf
			DB "in its window procedure (basically just repainting this text).", $cr, $lf
			DB "This concludes this test.", 0

ChildCreateFailMsg	DB "Failure creating child window!", 0


;============================================
; CODE
;============================================
.code


start:
	INVOKE	GetModuleHandle, NULL
	MOV	InstanceHandle, EAX

	INVOKE	WinMain, EAX
	INVOKE	ExitProcess, EAX


;====================================================================
; Mainline proc
;====================================================================

WinMain	PROC hInst:DWORD
	LOCAL	wc:WNDCLASSEX, msg:MSG, gpRect:RECT, wX:DWORD, wY:DWORD

; Get handle to small system font:
	INVOKE	GetStockObject, ANSI_VAR_FONT
	MOV	FontHandle, EAX

; Create  brush to set background color:
	INVOKE	CreateSolidBrush, $BkColor
	MOV	BkBrush, EAX

; Register class for parent window:
	MOV	wc.cbSize, SIZEOF WNDCLASSEX
	MOV	wc.style,  CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
	MOV	wc.lpfnWndProc, OFFSET MainWindowProc
	MOV	wc.cbClsExtra, NULL
	MOV	wc.cbWndExtra, NULL
	MOV	EAX, hInst
	MOV	wc.hInstance, EAX
	MOV	EAX, BkBrush
	MOV	wc.hbrBackground, EAX
	MOV	wc.lpszMenuName,  NULL
	MOV	wc.lpszClassName, OFFSET MainClassName
	MOV	wc.hIcon, NULL
	INVOKE	LoadCursor, NULL, IDC_ARROW
	MOV	wc.hCursor, EAX
	MOV	wc.hIconSm, 0
	INVOKE	RegisterClassEx, ADDR wc

	INVOKE	GetSystemMetrics, SM_CXSCREEN
	MOV	EDX, $mainWindowWidth
	CALL	CenterDim
	MOV	wX, EAX
	INVOKE	GetSystemMetrics, SM_CYSCREEN
	MOV	EDX, $mainWindowHeight
	CALL	CenterDim
	MOV	wY, EAX

; Create our main window:

	INVOKE	CreateWindowEx, WS_EX_OVERLAPPEDWINDOW, ADDR MainClassName, ADDR MainTitleText,
		$mainWinAttrs, wX, wY, $mainWindowWidth, $mainWindowHeight,
		NULL, NULL, hInst, NULL
	MOV	MainWinHandle, EAX
	INVOKE	ShowWindow, EAX, SW_SHOWNORMAL

; Create pushbutton:
	INVOKE	CreateWindowEx, WS_EX_OVERLAPPEDWINDOW, ADDR ButtonClassName, ADDR PBText,
		$PB_attrs, $PBX, $PBY, $PBWidth, $PBHeight,
		MainWinHandle, $PBID, hInst, NULL
	MOV	ButtonHandle, EAX
	INVOKE	SendMessage, EAX, WM_SETFONT, FontHandle, TRUE
	INVOKE	ShowWindow, ButtonHandle, SW_SHOWNORMAL

; Create the status bar:
	INVOKE	CreateStatusWindow, $SB_attrs, OFFSET NullString, MainWinHandle, $SBID
	MOV	StatusHandle, EAX
	MOV	EDX, EAX
; Get the height of the status bar:
	INVOKE	GetWindowRect, EDX, ADDR gpRect
	MOV	EAX, gpRect.bottom
	SUB	EAX, gpRect.top
	MOV	SBheight, EAX
; Divide status bar into parts:
	INVOKE	SendMessage, StatusHandle, SB_SETPARTS, $numStatusParts, ADDR StatusParts
	INVOKE	UpdateWindow, StatusHandle

; Create attribute checkboxes:
	CALL	CreateCheckboxes
;	invoke	MessageBox, MainWinHandle, addr heremsg, NULL, MB_OK
	CALL	UpdateStyleFlagDisplay
;	invoke	MessageBox, MainWinHandle, addr heremsg, NULL, MB_OK

;============= Message loop ===================
msgloop:
	INVOKE	GetMessage, ADDR msg, NULL, 0, 0
	OR	EAX, EAX				;EAX = 0 = exit
	JZ	exit
	INVOKE	TranslateMessage, ADDR msg
	INVOKE	DispatchMessage, ADDR msg
	JMP	msgloop

exit:	INVOKE	DeleteObject, BkBrush			;Delete brush.
	INVOKE	DeleteObject, FontHandle
	MOV	EAX, msg.wParam
	RET

WinMain		ENDP


;====================================================================
; Main Window Proc
;====================================================================

MainWindowProc	PROC hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
		LOCAL	wstyle:DWORD, gpRect:RECT, statusPtr:DWORD
		LOCAL	ps:PAINTSTRUCT, hDC:HDC

	MOV	EAX, uMsg
	CMP	EAX, WM_COMMAND
	JE	dowincmd
	CMP	EAX, WM_CREATE
	JE	docreate
	CMP	EAX, WM_CTLCOLORSTATIC
	JE	do_colorcheckbox
	CMP	EAX, WM_SIZE
	JE	dosize
	CMP	EAX, WM_CLOSE
	JE	doclose

dodefault:
; use DefWindowProc for all other messages:
	INVOKE	DefWindowProc, hWin, uMsg, wParam, lParam
	RET

dowincmd:
	MOV	AX, WORD PTR wParam
	CMP	AX, $PBID
	JE	do_createchild
	CALL	FindCheckbox
	CMP	EAX, -1					;No match?
	JE	dodefault
	MOV	EDX, EAX
	MOV	EAX, [EDX+ $chkbox.wstyle]
	MOV	wstyle, EAX
	MOV	EAX, [EDX + $chkbox.ID]
	INVOKE	IsDlgButtonChecked, MainWinHandle, EAX	;Get state of checkbox.
	CMP	EAX, BST_CHECKED
	MOV	EAX, wstyle				;This won't change the flags.
	JE	is_checked

; Button not checked, so remove its style from style word:
	NOT	EAX
	AND	WindowStyles, EAX
dwc40:	CALL	UpdateStyleFlagDisplay
	JMP	SHORT commonexit

is_checked:
	OR	WindowStyles, EAX
	JMP	dwc40	


docreate:
commonexit:
	XOR	EAX, EAX
	RET

do_colorcheckbox:
        INVOKE  SetBkColor, wParam, $BkColor
	MOV	EAX, BkBrush
	RET

dosize:
	INVOKE	GetClientRect, hWin, ADDR gpRect
	MOV	EDX, gpRect.bottom
	SUB	EDX, gpRect.top
	SUB	EDX, SBheight
	INVOKE	MoveWindow, StatusHandle, 0,  EDX, gpRect.right, SBheight, TRUE
	JMP	commonexit

doclose:
	INVOKE	PostQuitMessage, NULL
	MOV	EAX, TRUE
	RET

do_createchild:
	CMP	ChildHandle, NULL			;If window not yet created,
	JE	dcc20					;  create it,
	INVOKE	DestroyWindow, ChildHandle
	MOV	ChildHandle, NULL
dcc20:	INVOKE	CreateWindowEx,	WS_EX_LEFT, ADDR MainClassName, ADDR ChildTitleText, WindowStyles,
			$childX, $childY, $childWidth, $childHeight, MainWinHandle, $childID, InstanceHandle,
			NULL
	MOV	ChildHandle, EAX
	CMP	EAX, NULL				;Error creating window?
	JE	dcc77					;  Yes, alert user.
	INVOKE	ShowWindow, EAX, SW_SHOWNORMAL
	INVOKE	SetWindowLong, ChildHandle, GWL_WNDPROC, ChildProc
	MOV	OldChildProcPtr, EAX
	CALL	PutChildText
	JMP	commonexit

dcc77:	INVOKE	MessageBox, MainWinHandle, ADDR ChildCreateFailMsg, NULL, MB_OK
	JMP	commonexit

MainWindowProc	ENDP



;====================================================================
; Child Proc
;====================================================================

ChildProc	PROC hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
		LOCAL	hDC:HDC, hbr:HBRUSH, gpRect:RECT, ps:PAINTSTRUCT

	MOV	EAX, uMsg
	CMP	EAX, WM_PAINT
	JE	do_paint

do_default:
	INVOKE	CallWindowProc, OldChildProcPtr, hWin, uMsg, wParam, lParam
	RET

do_paint:
	CALL	PutChildText
	XOR	EAX, EAX
	RET

ChildProc	ENDP



;====================================================================
; CenterDim
;
; Returns half screen dimension (X or Y) minus half window dimension
;
; On entry,
;	EAX = screen dimension
;	EDX = window dimension
;
; Returns:
;	sdim/2 - wdim/2
;====================================================================

CenterDim	PROC

	SHR	EAX, 1				;divide screen dimension by 2
	SHR	EDX, 1				;divide window dimension by 2
	SUB	EAX, EDX
	RET					;Return w/# in EAX

CenterDim	ENDP



;====================================================================
; CreateCheckboxes()
;
; Creates checkbox controls for selecting child-window attributes
; from table (CheckboxInfo). Stores handles in table.
;====================================================================

CreateCheckboxes	PROC

	PUSH	EBX
	LEA	EBX, CheckboxInfo

ccb20:	MOV	EAX, [EBX  + $chkbox.ID]
	CMP	EAX, -1				;End o'list?
	JE	ccb77
	INVOKE	CreateWindowEx,	WS_EX_LEFT, ADDR ButtonClassName, [EBX + $chkbox.textPtr],
			$chkboxAttrs, [EBX + $chkbox.x], [EBX + $chkbox.y], [EBX + $chkbox.wdth],
			[EBX + $chkbox.height], MainWinHandle, [EBX + $chkbox.ID], InstanceHandle,
			NULL

	MOV	[EBX + $chkbox.handle], EAX	;Store handle.
	INVOKE	SendMessage, [EBX + $chkbox.handle], WM_SETFONT, FontHandle, TRUE
	INVOKE	CheckDlgButton, MainWinHandle, [EBX + $chkbox.ID], BST_UNCHECKED	;Set button state to unchecked.
	INVOKE	UpdateWindow, [EBX + $chkbox.handle]
	LEA	EBX, [EBX + SIZEOF $chkbox]	;Next entry in list.
	JMP	ccb20

ccb77:	POP	EBX
	RET

CreateCheckboxes	ENDP



;====================================================================
; FindCheckbox()
;
; Locates checkbox entry in table given a checkbox ID
;
; On entry,
;   EAX = ID
;
; On exit,
;   EAX--> checkbox entry (in CheckboxInfo array)
;   If no matching entry found, EAX = -1
;====================================================================

FindCheckbox		PROC

	LEA	EDX, CheckboxInfo
fcb10:	CMP	EAX, [EDX + $chkbox.ID]			;Be this the handle?
	JE	fcb88
	CMP	[EDX + $chkbox.ID], -1
	JE	fcb77
	LEA	EDX, [EDX + SIZEOF $chkbox]
	JMP	fcb10

fcb77:	MOV	EAX, -1
	RET

fcb88:	MOV	EAX, EDX
	RET

FindCheckbox		ENDP



;====================================================================
; PutChildText()
;
; Fills the child window with something to look at ("WindowTestText").
;====================================================================

PutChildText		PROC
	LOCAL	gpRect:RECT, hDC:HDC, ps:PAINTSTRUCT

	INVOKE	GetClientRect, ChildHandle, ADDR gpRect
	INVOKE	BeginPaint, ChildHandle, ADDR ps
	MOV	hDC, EAX
	INVOKE	SetBkColor, hDC, $BkColor
	MOV	EAX, gpRect.left
	ADD	EAX, 15
	MOV	gpRect.left, EAX
	MOV	EAX, gpRect.top
	ADD	EAX, 10
	MOV	gpRect.top, EAX
	INVOKE	DrawText, hDC, OFFSET WindowTestText, -1, ADDR gpRect, DT_LEFT OR DT_TOP OR DT_WORDBREAK
	INVOKE	EndPaint, ChildHandle, ADDR ps
	RET

PutChildText		ENDP



;====================================================================
; UpdateStyleFlagDisplay()
;
; Updates status bar display of WS_xxxx status word
;====================================================================

UpdateStyleFlagDisplay	PROC
	LOCAL	buffer[40]:BYTE

	MOV	EAX, WindowStyles
	PUSH	EDI
	LEA	EDI, buffer
	CALL	B2A_bin32
	POP	EDI
	INVOKE	SendMessage, StatusHandle, SB_SETTEXT, 0, ADDR buffer
	RET

UpdateStyleFlagDisplay	ENDP




;====================================================================
; B2A_bin32()
;
; Converts DWORD value to binary string of 32 digits
;
; On entry,
;   EAX = value to convert
;   EDI--> buffer to store digits (must be large enough to contain
;		terminating zero at end)
;====================================================================

B2A_bin32	PROC

	PUSH	EBX
	PUSH	ECX
	MOV	EBX, EAX
	MOV	ECX, 32
	MOV	EDX, 80000000H			;Bit mask (start @ high end)
bb10:	TEST	EBX, EDX
	JZ	bb20
	MOV	AL, '1'
	JMP	SHORT bb30
bb20:	MOV	AL, '0'
bb30:	STOSB
	SHR	EDX, 1				;Move mask bit.
	LOOP	bb10
	MOV	BYTE PTR [EDI], 0		;NULL-terminate string.
	POP	ECX
	POP	EBX
	RET

B2A_bin32	ENDP


	END	start

